import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Collections;
import java.util.LinkedList;

public class Main {




    public static class Ant implements Comparable<Ant>
    {
        int position;
        int previosPosition;
        boolean isGoingRight;

        public Ant(int position, boolean isGoingRight) {
            this.position = position;
            this.isGoingRight = isGoingRight;
            this.previosPosition = position;
        }


        public int getPosition() {
            return position;
        }

        public boolean isGoingRight() {
            return isGoingRight;
        }

        public int getPreviosPosition() {
            return previosPosition;
        }

        public void setPreviosPosition(int previosPosition) {
            this.previosPosition = previosPosition;
        }

        public void move() {
            previosPosition = position;
            if(isGoingRight)
            {
                position++;
            } else  {
                position--;
            }
        }

        @Override
        public int compareTo(Ant ant) {

            return position - ant.getPosition();
        }

        @Override
        public String toString() {
            return "Ant{" +
                    "position=" + position +
                    ", isGoingRight=" + isGoingRight +
                    '}';
        }
    }



    public static void main(String[] args) throws IOException {

        int secNum;
        BufferedReader in = new BufferedReader(new InputStreamReader(System.in));

        while (true)
        {
            secNum = 0;
            String tmp = in.readLine();
            if(tmp == null) break;
            int woodLength = Integer.parseInt(tmp.split(" ")[0]);
            int antNum = Integer.parseInt(tmp.split(" ")[1]);

            LinkedList<Ant> ants = new LinkedList<>();

            for(int i = 0; i < antNum; i++)
            {
                tmp = in.readLine();
                int antPosition = Integer.parseInt(tmp.split(" ")[0]);
                String direction = tmp.split(" ")[1];
                ants.add(new Ant(antPosition, direction.equals("R") ? true : false));
            }

            Collections.sort(ants);

            while (true)
            {
                for(int i = 0; i < ants.size(); i++)
                {
                    Ant curr = ants.get(i);
                    if(curr.isGoingRight())
                    {
                        if (ants.get(i+1).getPosition() != curr.getPosition() + 1)
                        {
                            curr.move();
                        }
                    } else {
                        Ant next = ants.get(i-1);
                        if ((next.getPosition() == curr.getPosition() - 1) && next.getPreviosPosition() == curr.getPosition() - 2)
                        {
                            curr.move();
                        } else if (next.getPosition() != curr.getPosition() - 1)
                        {
                            curr.move();
                        }
                    }

                    if(curr.getPosition() < 0 || curr.getPosition() > woodLength)
                    {
                        ants.remove(curr);
                    }
                }
                secNum++;
                if(ants.isEmpty()){
                    System.out.println("The last ant will fall down in " + secNum + " seconds.");
                    break;
                }

            }

            ants.clear();

        }


    }
}
